// Generated by Bisonc++ V2.7.0 on Thu, 20 May 2010 16:52:47 +1100

#ifndef Parser_h_included
#define Parser_h_included

// $insert baseclass
#include "parserbase.h"
// $insert scanner.h
#include "scanner.h"

#include <vector>
#include <set>
#include <algorithm>
#include <fstream>


#define OPERATOR_EXP(ret_, OP_, lhs_, rhs_) \
	TokenExpression *e = new TokenExpression(OP_, lhs_, rhs_);\
	ret_ = Semantic(e);\

#define MAX_INCLUDE_DEPTH 20

#undef Parser

typedef struct {
	yy_buffer_state *buf_state;
	int lineno;
	std::string *filename;
} ScannerState;

class Parser: public ParserBase
{
    // $insert scannerobject
    Scanner d_scanner;
        
    public:
		Parser(std::istream *in, std::string *filename);
        int parse();
		void setIncludePath(std::vector <std::string> &path) {include_path = path;};

    private:

		std::vector <std::vector<Semantic> > call_params_list;
		
		std::vector <std::string> include_path;

        void error(char const *msg);    // called on (syntax) errors
        int lex();                      // returns the next token from the
                                        // lexical scanner. 
        void print();                   // use, e.g., d_token, d_loc

    // support functions for parse():
        void executeAction(int ruleNr);
        void errorRecovery();
        int lookup(bool recovery);
        void nextToken();

		void push_call();
		void pop_call();
	
		int findLocalVar(std::string name);

		std::string findInclude(std::string&);

		std::vector<std::string> params_list;
		std::vector<std::string> locals_list;
		std::vector<std::string> strings_list;

		ScannerState include_stack[MAX_INCLUDE_DEPTH];
        int include_stack_ptr;

};

inline void Parser::error(char const *msg)
{
    std::cerr << msg << " in " << *(d_loc__.filename) << " line " << d_loc__.line << '\n';
}

inline Parser::Parser(std::istream *in, std::string *filename) :d_scanner(&d_val__, &d_loc__, in), include_stack_ptr(0) {d_loc__.filename = filename;};

// $insert lex
inline int Parser::lex()
{
    return d_scanner.yylex();
}

// $insert print
inline void Parser::print()
{
	d_val__.setLineNo(d_loc__.line);
}

inline void Parser::push_call() {call_params_list.push_back(std::vector<Semantic>());}
inline void Parser::pop_call() {call_params_list.pop_back();}

inline int Parser::findLocalVar(std::string name)
{
	int delta = 0;
	typedef std::vector<std::string>::iterator it_type;
	it_type i = std::find<it_type, std::string>(params_list.begin(), params_list.end(), name);
	if (i == params_list.end())  {
		i = std::find<it_type, std::string>(locals_list.begin(), locals_list.end(), name);
		if (i == locals_list.end()) {
			delta = -1;
		} else {
			delta = (int)(i - locals_list.begin()) + params_list.size();
		}
	} else {
		delta = i - params_list.begin();
	}
	return delta;
}

inline std::string Parser::findInclude(std::string &name)
{
	std::ifstream f;
	f.open(name.c_str());
	if (f.is_open()) return name;
	unsigned int i;
	for (i = 0; i < include_path.size(); i++) {
		std::string fname = include_path[i] + '/' + name;
		f.open(fname.c_str());
		if (f.is_open()) return fname;
	}
	return "";
}

#endif
