#ifndef _SCANNER_H_
#define _SCANNER_H_

#include <semantic.h>
#include <string>
#include <vector>
#include "parserloc.h"

#if ! defined(_SKIP_YYFLEXLEXER_) && ! defined(_SYSINC_FLEXLEXER_H_)
#include <FlexLexer.h>
#define _SYSINC_FLEXLEXER_H_
#endif

class Scanner: public yyFlexLexer
{
    Semantic *d_semval;
	std::string quoted_str;
	ParserLocation *loc;
	int d_level;

    public:
        Scanner(Semantic *semval, ParserLocation* l, std::istream *in = 0);
        int yylex();
		yy_buffer_state* currentBuffer();
		void enterInclude() {d_level++;};
		void leaveInclude() {d_level--;};
		void setLineNo(int l) {yylineno = l;};
};

inline Scanner::Scanner(Semantic *semval, ParserLocation *l, std::istream *in)
:
	yyFlexLexer(in),
    d_semval(semval),
	loc(l),
	d_level(0)
{}

inline yy_buffer_state* Scanner::currentBuffer()
{
	return ( (yy_buffer_stack) ? (yy_buffer_stack)[(yy_buffer_stack_top)] : NULL);
}

#endif

