%{
    #define _SKIP_YYFLEXLEXER_
    #include "scanner.ih"
	#include "nativedescscanner.h"
	#include "nativedescparser.h"

%}

%option yyclass="NativeDescScanner" outfile="nativedescscanner.cc"
%option c++ 8bit warn noyywrap yylineno
%option debug
%option case-insensitive
%option prefix="tyy"

SYMBOL [_a-z][_a-z0-9]*


WS [ \t\r\n]
NL [\n]


%%


"EVENTS" {return NativeDescParser::T_EVENTS;}
"NATIVE" {return NativeDescParser::T_NATIVE;}
"INT" {return NativeDescParser::T_INT;}
"STRING" {return NativeDescParser::T_STRING;}
"ARRAY" {return NativeDescParser::T_ARRAY;}
"LIST" {return NativeDescParser::T_LIST;}
"RAM" {return NativeDescParser::T_RAM;}
"PROGRAM" {return NativeDescParser::T_PROGRAM;}


[a-z_][a-z0-9_]+ { *d_semval = yytext;	return NativeDescParser::T_ID;}
[0-9]+ { *d_semval = yytext;	return NativeDescParser::T_NUMBER;}


{WS} {}
.  {return *yytext;}

%%

